---
title: AudioBufferSourceNode.AudioBufferSourceNode()
slug: Web/API/AudioBufferSourceNode/AudioBufferSourceNode
tags:
  - API
  - Audio
  - AudioBufferSourceNode
  - Constructor
  - Media
  - Reference
  - Web Audio API
---
<p>{{APIRef("Web Audio API")}}</p>

<p><span class="seoSummary">The <strong><code>AudioBufferSourceNode()</code></strong> constructor creates a new {{domxref("AudioBufferSourceNode")}} object instance.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var audioBufferSourceNode = new AudioBufferSourceNode(context, options)</pre>

<h3 id="Parameters">Parameters</h3>

<p><em>Inherits parameters from the </em><em>{{domxref("AudioNodeOptions")}} dictionary</em>.</p>

<dl>
 <dt><em>context</em></dt>
 <dd>A reference to an {{domxref("AudioContext")}}.</dd>
 <dt><em>options</em> {{optional_inline}}</dt>
 <dd>Options are as follows:
 <ul>
  <li><code>buffer</code>: An instance of {{domxref("AudioBuffer")}} to be played.</li>
  <li><code>detune</code>: A value in cents to modulate the speed of audio stream rendering. Its nominal range is (-∞ to +∞). The default is <code>0</code>.</li>
  <li><code>loop</code>: A boolean indicating whether the audio should play in a loop. The default is <code>false</code>. If the loop is dynamically modified during playback, the new value will take effect on the next processing block of audio.</li>
  <li><code>loopEnd</code>: An optional value, in seconds, where looping should end if the loop attribute is <code>true</code>. The default is <code>0</code>. Its value is exclusive to the content of the loop. The sample frames, comprising the loop, run from the values <code>loopStart</code> to <code>loopEnd</code>-(1/<code>sampleRate</code>). It's sensible to set this to a value between 0 and the duration of the buffer. If <code>loopEnd</code> is less than 0, looping will end at 0. If <code>loopEnd</code> is greater than the duration of the buffer, looping will end at the end of the buffer. This attribute is converted to an exact sample frame offset within the buffer, by multiplying by the buffer's sample rate and rounding to the nearest integer value. Thus, its behavior is independent of the value of the <code>playbackRate</code> parameter.</li>
 </ul>

 <ul>
  <li><code>loopStart</code>: An optional value in seconds, where looping should begin if the loop attribute is <code>true</code>. The default is <code>0</code>. It's sensible to set this to a value between 0 and the duration of the buffer. If <code>loopStart</code> is less than 0, looping will begin at 0. If <code>loopStart</code> is greater than the duration of the buffer, looping will begin at the end of the buffer. This attribute is converted to an exact sample frame offset within the buffer, by multiplying by the buffer's sample rate and rounding to the nearest integer value. Thus, its behavior is independent of the value of the <code>playbackRate</code> parameter.</li>
  <li><code>playbackRate</code>: The speed at which to render the audio stream. Its default value is <code>1</code>. This parameter is k-rate. This is a compound parameter with detune. Its nominal range is (-∞ to +∞).</li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A new {{domxref("AudioBufferSourceNode")}} object instance.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API','#AudioBufferSourceNode','AudioBufferSourceNode()')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_Compatibility">Browser Compatibility</h2>

<div>

<p>{{Compat("api.AudioBufferSourceNode.AudioBufferSourceNode")}}</p>
</div>
